import greenfoot.*;
public class Geist extends SmoothMover
{
    private int typ; //0=Blinky, 1=Pinky, 2=Inky, 3=Clyde
    private int direction; //0=nach rechts, 1=nach unten, 2=nach links, 3=nach oben
    private int nextDirection;
    private int img; //0 oder 1 abwechselnd
    private int imgTimer;
    
    private int attModus; //0=Angriff, 1=Heimatecke
    private boolean blau; public boolean getBlau() {return blau;}
    private boolean wechsel;
    private boolean imHaus;
    private boolean verlässtHaus;
    private int elroy = 0; public int getElroy() {return elroy;} //für roten Geist {0,1,2}
    
    private int[] ziel = new int[2]; //Ziel"feld"
    private int[] aktuell = new int[2]; //aktuelles "Feld"
    private int[] heimat = new int[2]; //Heimat"feld"
    
    private boolean tot; public boolean amLeben() {return !tot;}
    
    public static Welt welt;
    public static PacMan pac;
    private static Geist[] geistHaus = new Geist[3];
    
    public Geist(int person)
    {
        typ = person;
        attModus = 1;
        switch (typ)
        {
            case 0: direction = 2; heimat[0]=25; heimat[1]= 0; break;
            case 1: direction = 1; heimat[0]= 3; heimat[1]= 0; geistHaus[0] = this; imHaus = true; break;
            case 2: direction = 3; heimat[0]=27; heimat[1]=35; geistHaus[1] = this; imHaus = true; break;
            case 3: direction = 3; heimat[0]= 0; heimat[1]=35; geistHaus[2] = this; imHaus = true; break;
        }
        nextDirection = direction;
        setImage(Welt.img_Geist[typ][direction][img]);
    }
    
    protected void addedToWorld()
    {
        nextDirection = zielBestimmen();
    }
    
    public void act()
    {
        if (!welt.gestartet()) return;
        
        if (++imgTimer==10) {img=(img+1)%2; imgTimer=0;}
        
        setImage(tot ? Welt.img_Geist_tot[nextDirection] : blau && (welt.getPowerUp()>110 || welt.getPowerUp()<100 && ((welt.getPowerUp()-1)/10)%2==0) ? Welt.img_Geist_blau[img] : Welt.img_Geist[typ][nextDirection][img]);
        
        
        if (imHaus)
        {
            //blau = false;
            if (verlässtHaus)
            {
                if (getY() == 140)
                {
                    if (getX() == 112) {nextDirection=3; direction=3;}
                    else direction = (int) Math.signum(getX()-112)+1;
                }
                
                if (getY() == 116)
                {
                    direction = 2;
                    nextDirection = 2;
                    imHaus = false;
                    verlässtHaus = false;
                }
            }
            setImage(blau && (welt.getPowerUp()>110 || welt.getPowerUp()<100 && ((welt.getPowerUp()-1)/10)%2==0) ? Welt.img_Geist_blau[img] : Welt.img_Geist[typ][nextDirection][img]);
            
            setRotation(direction*90);
            move(welt.getGeistSpeed(this));
            setRotation(0);
            if ( (!verlässtHaus || getX() != 112 || direction==1) && welt.wand(getX()/8, getY()/8 + (2-direction)%2))
            {
                direction = (direction + 2) % 4;
                nextDirection = direction;
            }
            
            return;
        }
        
        aktuell[0] = getX()/8;
        aktuell[1] = getY()/8;
        
        setRotation(direction*90);
        move(welt.getGeistSpeed(this));
        int w = getWorld().getWidth();
        setLocation((getExactX()+w)%w, getExactY());
        setRotation(0);
        
        
        
        if (getX()/8 != aktuell[0] || getY()/8 != aktuell[1]) //neues Feld betreten
        {
            aktuell[0] = getX()/8;
            aktuell[1] = getY()/8;
            
            if (wechsel && !tot) {nextDirection = (direction+2)%4; wechsel=false;}
            else nextDirection = zielBestimmen();
            
            //System.out.println(direction + " " + nextDirection);
        }
        
        if (getX()%8==4 && getY()%8==4)
        {
            direction = nextDirection;
            //System.out.println(direction);
        }
        
    }
    
    public void elroy() {elroy++;}
    
    private boolean tunnel()
    {
        return Welt.tunnel(this);
    }
    
    public void kill() {blau = false; tot = true;}
    
    
    public void wechselModus()
    {
        attModus = (attModus+1)%2;
        wechsel = true;
    }
    
    public void setBlau(int b) {blau = b>0; if (b>-1) wechsel = true;}
    
    public static void geistFreilassen(boolean wegenPunkten)
    {
        for (int i=0; i<3; i++) //nächster in der Schlange wird freigelassen
        {
            if (geistHaus[i] != null && !geistHaus[i].verlässtHaus)
            {
                geistHaus[i].verlässtHaus = true;
                break;
            }
            
            //falls es nicht wegen Punkten war, wird der nächste freigegeben, auch wenn es gerade irgendwie (null, null, gh3) ist
            if (wegenPunkten) break;
        }
        
        
        if (wegenPunkten) //keine Verschiebung, wenn wegen Timer
        {
            geistHaus[0] = geistHaus[1];
            geistHaus[1] = geistHaus[2];
        }
    }
    
    
    
    private int zielBestimmen()
    {
        if (tot)
        {
            ziel[0] = 14;
            ziel[1] = 17;
            
            if (aktuell[0] == ziel[0] && aktuell[1] == ziel[1])
            {
                tot = false;
                imHaus = true;
                verlässtHaus = true;
            }
        }
        else if (attModus==1 && (elroy == 0 || !welt.getGeist(3).imHaus))
        {
            ziel[0] = heimat[0];
            ziel[1] = heimat[1];
        }
        else
        {
            switch (typ)
            {
                case 0: //Blinky
                ziel[0] = pac.getX()/8;
                ziel[1] = pac.getY()/8;
                break;
                
                case 1: //Pinky
                ziel[0] = (int) ( pac.getX()/8 + 4 * Math.cos(pac.getDir()*Math.PI/2) );
                ziel[1] = (int) ( pac.getY()/8 + 4 * Math.sin(pac.getDir()*Math.PI/2) );
                break;
                
                case 2: //Inky
                Actor blinky = welt.getGeist(0);
                ziel[0] = blinky.getX()/8 + (int) (2 * (pac.getX()/8 + 2 * Math.cos(pac.getDir()*Math.PI/2) - blinky.getX()/8));
                ziel[1] = blinky.getY()/8 + (int) (2 * (pac.getY()/8 + 2 * Math.sin(pac.getDir()*Math.PI/2) - blinky.getY()/8));
                break;
                
                case 3: //Clyde
                if ( Math.hypot((int)(getX()/8)-(int)(pac.getX()/8),(int)(getY()/8)-(int)(pac.getY()/8)) < 8)
                {
                    ziel[0] = heimat[0];
                    ziel[1] = heimat[1];
                }
                else
                {
                    ziel[0] = pac.getX()/8;
                    ziel[1] = pac.getY()/8;
                }
                break;
            }
        }
        
        
        
        double distanz = 1000000;
        boolean w[] =
        {
            welt.wand(aktuell[0] + 1, aktuell[1]    , tot),
            welt.wand(aktuell[0]    , aktuell[1] + 1, tot),
            welt.wand(aktuell[0] - 1, aktuell[1]    , tot),
            welt.wand(aktuell[0]    , aktuell[1] - 1, tot)
        };
        int j = -1;
        int x=getX()/8, y=getY()/8;
        
        for (int i=3; i>-1; i--)
        {
            if (i == (direction+2)%4) continue;
            
            
            if (!blau && i==3 && (y==14 || y==26) && (x==12 || x==15)) continue;
            
            if (!w[i])
            {
                double dx = aktuell[0]+Math.cos(i*Math.PI/2) - ziel[0];
                double dy = aktuell[1]+Math.sin(i*Math.PI/2) - ziel[1];
                double d = !blau ? Math.hypot(dx, dy) : Greenfoot.getRandomNumber(1000000);
                if (d<distanz)
                {
                    distanz = d;
                    j = i;
                }
            }
        }
        //if (j == -1) System.out.println("FEHLER: Keine Richtung gefunden");
        return j;
    }
}