import greenfoot.*;
import java.util.List;
import java.util.ArrayList;
//import java.awt.GraphicsEnvironment;
public class ScoreBoard extends World
{
    // The vertical gap between user images in the scoreboard:
    //private static int GAP;
    // The height of the "All Players"/"Near Me" text at the top:
    //private static final int HEADER_TEXT_HEIGHT = 20*Welt.sizeFactor;
    // The main text color:
    private static final Color MAIN_COLOR = new Color(255, 0, 0); // rot
    // The score color:
    //private static final Color SCORE_COLOR = new Color(0x00, 0x0, 0xFF); // blau
    // The background colors:
    private static final Color BACKGROUND_COLOR = new Color(127, 127, 127); //grau -- 0, 200, 255); //hellblau
    private static final Color BACKGROUND_HIGHLIGHT_COLOR = new Color(0, 200, 0); //grün
    
    private static final int fontSize = 15;
    
    //int 0 = level
    //int 1 = punktzahl
    //sortieren jeweils möglich
    
    
    
    //s = sortiert
    private ArrayList[] s_namen;
    private ArrayList[] s_level;
    private ArrayList[] s_punkte;
    
    
    
    private GreenfootImage img[] = new GreenfootImage[2];
    
    private Knopf[] knopf = {new Knopf(1), new Knopf(2), new Knopf(3)};
    
    private int sort = 0;
    
    public ScoreBoard()
    {
        super(Welt.x, Welt.y, Welt.sizeFactor);
        //GAP = 2*Welt.sizeFactor;
        
        /*String fonts[] = 
        GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
    
        for ( int i = 0; i < fonts.length; i++ )
        {
          System.out.println(fonts[i]);
        }*/
        
        addObject(knopf[0], getWidth()-50, 12);
        //addObject(knopf[1], 50, 20);
        
        
        neuLaden();
        addObject(knopf[2-sort], 48, 12);
        erstelleBild(sort);
    }
    
    /*public void refresh()
    {
        neuLaden();
        erstelleBild(sort);
    }*/
    
    public void sortierungÄndern()
    {
        addObject(knopf[1+sort], 50-sort*2, 12);
        sort = (sort+1)%2;
        removeObject(knopf[1+sort]);
        erstelleBild(sort);
    }
    
    private void erstelleBild(int sortierung) //0=nach Punkten, 1=nach Level
    {
        if (img[sortierung] != null) {setBackground(img[sortierung]); return;}
        
        img[sortierung] = new GreenfootImage(getWidth(), getHeight());
        img[sortierung].setColor(Color.BLACK);
        img[sortierung].fill();
        
        
        if (s_punkte == null)
        {
            img[sortierung].scale(getWidth()*Welt.sizeFactor, getHeight()*Welt.sizeFactor);
            img[sortierung].setColor(Color.RED);
            img[sortierung].setFont(new Font("Courier New", false, false, fontSize*Welt.sizeFactor));
            img[sortierung].drawString("Loading failed!", img[sortierung].getWidth()/2-46*Welt.sizeFactor, img[sortierung].getHeight()/2);
        }
        else if (s_punkte[sortierung].size()>0)
        {
            final int x=img[sortierung].getWidth(), y=img[sortierung].getHeight();
        
            
            //img[sortierung].setFont(new Font("Courier", true, false, fontSize*Welt.sizeFactor));
            final int pixelsPerUser = 20;
            // Calculate how many users we have room for:
            
            final int topSpace = 24;
            final int bottomSpace = 2;
            final int numUsers = (y - topSpace - bottomSpace) / pixelsPerUser;
            final int left=2, top=topSpace+1, right=x-2, bottom=topSpace+numUsers*pixelsPerUser+1;
            
            int yy = top+1;
            UserInfo me = UserInfo.getMyInfo();
            
            
            img[sortierung].setColor(new Color(255,127,0));
            img[sortierung].fillRect(left-1, top-1, right-left+2, bottom-top+1+2);
            img[sortierung].setColor(Color.BLACK);
            //img[sortierung].fillRect(left+1, top-GAP+1, right-left-2, bottom-top-2);
            //img[sortierung].drawRect(left+1, top-GAP+1, right-left-2, bottom-top-2);
            img[sortierung].scale(getWidth()*Welt.sizeFactor, getHeight()*Welt.sizeFactor);
            Color c;
            for (int i=0; i<s_level[sortierung].size(); i++)
            {
                if (i==numUsers) break;
                //img[sortierung].setColor(new Color(255,127,0));
                //if (i != 0) img[sortierung].fillRect(left, top+i*20*Welt.sizeFactor-Welt.sizeFactor*2, right-left, Welt.sizeFactor);
                
                
                if (me != null && s_namen[sortierung].get(i).equals(me.getUserName()))
                {
                    // Highlight our row:
                    c = BACKGROUND_HIGHLIGHT_COLOR;
                }
                else
                {
                    c = BACKGROUND_COLOR;
                }
                img[sortierung].setColor(c);//new Color(127, 127, 127, 255));
                img[sortierung].fillRect((left+1)*Welt.sizeFactor, yy*Welt.sizeFactor, (right-left-2)*Welt.sizeFactor, (pixelsPerUser-1)*Welt.sizeFactor);
                img[sortierung].setColor(new Color(255,0,0));
                int xx = left+2, t=0;
                //img.drawImage(new GreenfootImage("#" + (i+1), 14, MAIN_COLOR, new Color(0,0,0,0)), xx, yy);
                if (i == 0 ||
                    (sortierung==0 && (int)s_punkte[sortierung].get(i) < (int)s_punkte[sortierung].get(i-1))
                    || (sortierung==1 && (int)s_level[sortierung].get(i) < (int)s_level[sortierung].get(i-1)))
                {
                    GreenfootImage text = new GreenfootImage(30*Welt.sizeFactor, (pixelsPerUser-1)*Welt.sizeFactor);
                    //text.setColor(Color.YELLOW);
                    //text.fill();
                    text.setColor(MAIN_COLOR);
                    text.setFont(new Font("Courier New", true, false, fontSize*Welt.sizeFactor));
                    text.drawString("#" + (i+1), 0, fontSize*Welt.sizeFactor);
                    img[sortierung].drawImage(text, xx*Welt.sizeFactor, yy*Welt.sizeFactor);
                    //img[sortierung].drawImage(new GreenfootImage("# " + (i+1), fontSize*Welt.sizeFactor, MAIN_COLOR, new Color(0,0,0,0)), xx*Welt.sizeFactor, yy*Welt.sizeFactor);
                }
                xx += 27;
                int score = sortierung==0 ? (int)s_punkte[sortierung].get(i) : (int)s_level[sortierung].get(i);
                GreenfootImage text = new GreenfootImage(65*Welt.sizeFactor, (pixelsPerUser-1)*Welt.sizeFactor);
                //text.setColor(Color.YELLOW);
                //text.fill();
                text.setColor(MAIN_COLOR);
                text.setFont(new Font("Courier New", true, false, fontSize*Welt.sizeFactor));
                String numString = ""+score;
                int scoreDigits = numString.length();
                text.drawString("" + score, (7-scoreDigits)*9*Welt.sizeFactor, fontSize*Welt.sizeFactor);
                img[sortierung].drawImage(text, xx*Welt.sizeFactor, yy*Welt.sizeFactor);
                //GreenfootImage scoreImg = new GreenfootImage("" + score, fontSize*Welt.sizeFactor, MAIN_COLOR, new Color(0,0,0,0));
                //img[sortierung].drawImage(scoreImg, xx*Welt.sizeFactor-scoreImg.getWidth(), yy*Welt.sizeFactor);
                //img[sortierung].drawString(""+score, xx-scoreImg.getWidth(), yy);
                xx += 70;
                int size = fontSize*Welt.sizeFactor;
                String name = (String)s_namen[sortierung].get(i);
                int nameLength = name.length();
                //GreenfootImage imgName = new GreenfootImage(name, size, MAIN_COLOR, new Color(0,0,0,0));
                while (nameLength*size*9/fontSize>120*Welt.sizeFactor)//imgName.getWidth()>60)
                {
                    //System.out.println(size+", "+nameLength);
                    size--;
                    //imgName = new GreenfootImage((String)s_namen[sortierung].get(i), size, MAIN_COLOR, new Color(0,0,0,0));
                }
                
                text = new GreenfootImage(120*Welt.sizeFactor, (pixelsPerUser-1)*Welt.sizeFactor);
                //text.setColor(Color.YELLOW);
                //text.fill();
                text.setColor(MAIN_COLOR);
                text.setFont(new Font("Courier New", true, false, size));
                text.drawString((String)s_namen[sortierung].get(i), 0, text.getHeight()/2+size/3);//((fontSize*Welt.sizeFactor-size)/(1)));
                img[sortierung].drawImage(text, xx*Welt.sizeFactor, yy*Welt.sizeFactor);
                //img[sortierung].drawImage(imgName, xx*Welt.sizeFactor, (yy+(16*Welt.sizeFactor-size)/(2*Welt.sizeFactor))*Welt.sizeFactor);
                //img[sortierung].drawString((String)s_namen[sortierung].get(i), xx, yy-1);
                yy += 20;
            }
            
        }
        else
        {
            img[sortierung].setColor(Color.RED);
            img[sortierung].setFont(new Font("Courier", false, false, fontSize*Welt.sizeFactor));
            img[sortierung].drawString("No data yet!", getWidth()/2-38, getHeight()/2);
        }
        
        
        setBackground(img[sortierung]);
    }
    
    private void neuLaden()
    {
        if (UserInfo.isStorageAvailable())
        {
            s_namen = new ArrayList[] {new ArrayList(0), new ArrayList(0)};
            s_level = new ArrayList[] {new ArrayList(0), new ArrayList(0)};
            s_punkte = new ArrayList[] {new ArrayList(0), new ArrayList(0)};
            
            
            //temporär
            ArrayList[] namen = {new ArrayList(0), new ArrayList(0)};
            ArrayList[] level = {new ArrayList(0), new ArrayList(0)};
            ArrayList[] punkte = {new ArrayList(0), new ArrayList(0)};
            for (UserInfo u : (List<UserInfo>) UserInfo.getTop(0))
            {
                namen[0].add(u.getUserName());   namen[1].add(u.getUserName());
                level[0].add(u.getInt(1));       level[1].add(u.getInt(1));
                punkte[0].add(u.getInt(0));      punkte[1].add(u.getInt(0));
            }
            
            //Spieler mit 0 Punkten werden nicht angezeigt
            while(punkte[0].contains(0))
            {
                namen[1].remove( punkte[0].indexOf(0) );
                level[1].remove (punkte[0].indexOf(0) );
                punkte[1].remove( punkte[0].indexOf(0) );
                
                namen[0].remove( punkte[0].indexOf(0) );
                level[0].remove (punkte[0].indexOf(0) );
                punkte[0].remove( punkte[0].indexOf(0) );
            }
            
            
            
            /** sortiere nach Punkten */
            while(!punkte[0].isEmpty()) //solange in der Liste "original" noch Spieler vorhanden sind
            {
                /** finde die höchste verbleibende Punktzahl und speichere den Index **/
                int score = 0; int j = 0;
                for (int i=0; i<punkte[0].size(); i++)
                {
                    if ((int)punkte[0].get(i) > score || (int)punkte[0].get(i) == score && (int)level[0].get(i) > (int)level[0].get(j))
                    {
                        score = (int)punkte[0].get(i);
                        j = i;
                    }
                }
                /** Speichere Namen und Punktzahl des besten verbliebenen in der Liste "sortiert" **/
                s_namen[0].add( (String)namen[0].get(j) );
                s_punkte[0].add( (int)punkte[0].get(j) );
                s_level[0].add( (int)level[0].get(j) );
                
                /** Lösche diesen Spieler und seine Punktzahl aus der Liste "original" **/
                namen[0].remove(j);
                punkte[0].remove(j);
                level[0].remove(j);
            }
            
            /** sortiere nach Level */
            while(!level[1].isEmpty()) //solange in der Liste "original" noch Spieler vorhanden sind
            {
                /** finde die höchste verbleibende Punktzahl und speichere den Index **/
                int lvl = 0; int j = 0;
                for (int i=0; i<punkte[1].size(); i++)
                {
                    if ((int)level[1].get(i) > lvl || (int)level[1].get(i) == lvl && (int)punkte[1].get(i) > (int)punkte[1].get(j))
                    {
                        lvl = (int)level[1].get(i);
                        j = i;
                    }
                }
                /** Speichere Namen und Punktzahl des besten verbliebenen in der Liste "sortiert" **/
                s_namen[1].add( (String)namen[1].get(j) );
                s_punkte[1].add( (int)punkte[1].get(j) );
                s_level[1].add( (int)level[1].get(j) );
                
                /** Lösche diesen Spieler und seine Punktzahl aus der Liste "original" **/
                namen[1].remove(j);
                punkte[1].remove(j);
                level[1].remove(j);
            }
        }
    }
}
